      SUBROUTINE ANITO2(ALL,NR,NSOLMX,WMOL,DOBS,PRNTMR,PRNTLN,NTST,
     1  NRRUN)
C-----------------------------------------------------------------------
C  THIS IS THE SECOND HALF OF THE MAIN PROGRAM.
C  THIS PART IS CALLED WHEN THE ZONES HAVE BEEN ESTABLISHED AND
C  COMBINATIONS HAVE BEEN MADE THAT COULD RESULT IN CORRECT LATTICES.
C-----------------------------------------------------------------------
C  .... CHANGED:  210585    ADDED SUMM OUTPUT+ /HISYM /
C  .... CHANGED:  111085    REPLACED OUTPUT FOR /HISYM/ BY *SYMPRT*
C  .... CHANGED:  271185    ADDED SRTSYM (SORTS HIGH-SYM LATTICES)
C  .... CHANGED:  080486    ADDED SOME 'NSUMM' OUTPUT
C  .... CHANGED:  150986    REMOVED POSS. INFINITE LOOP 2000-2100
C  .... changed:  300493    Added output on CRT-monitor.
C  last changed:  061193    Deleted output on CRT-monitor.
C-----------------------------------------------------------------------
      DIMENSION OLD(6)
      INTEGER  H
C-----------------------------------------------------------------------
C
C        ****************************
C        * ATTENTION   H = INTEGER  *
C        ****************************
C
C-----------------------------------------------------------------------
      LOGICAL SELF,ENL,TEST,ALL,ZERREF
      CHARACTER*1 BRAVTP(6)
      CHARACTER NAME*80,CARD*80,SNAME*70,INTSY*2
      COMMON /LINES / IDOC,INP,IOUT ,NCRT,MAX,OBS(40),CEL(10)
      COMMON /CHARCM/ NAME,CARD,INTSY(50)
      COMMON /PARMS / TOL2,TOL3,WAVEL,FMINEQ,FMINIM,SELF,ENL,TEST,LIST,
     *                NSYST(3),OBSMT(40),OBSPT(40),TWTHET(40),TOLG
      COMMON /TEMRES/ LINCO,NQ2,NINDEX,INDEX(40),ROSTER(150,12)
      COMMON /CONSTS/ NSUMM,RAD,TWORAD,RRAD,HLFLAM,WAVSQR,STORE(200,9)
      COMMON /THETAS/ ZERTOT,OBSTET(40),SHFTET(40),TETPT(40),TETMT(40)
      COMMON /HISYM / ZERREF,ISOL,SYMCON(12,6),NMATCH(45)
      DATA  BRAVTP(1)/'A'/,BRAVTP(2)/'B'/,BRAVTP(3)/'C'/
     *   ,  BRAVTP(4)/'I'/,BRAVTP(5)/'F'/,BRAVTP(6)/'P'/
      SNAME=NAME
      IF (ALL) THEN
         N4=NR
         GO TO 2000
      END IF
C  ---------------------------------------------------------------------
C  ALL IS  ABUSED HERE TO EXECUTE THE JUMP FROM AAITO1 TO 2000
C  WHEN COMPLETE LATTICES HAVE BEEN GIVEN AS INPUT.
C  ---------------------------------------------------------------------
      CALL NTEST(NTST,5)
      WRITE(NCRT,'(// 78(1H*) / 10(1H ),
     * ''Finding lattices from 2 intersecting zones starts here'',
     * / 78(1H*) )' )
C     WRITE(NCRT,'(///'' FINDING THE COMPLETE LATTICES TAKES SOME'',
C    1 ''  TIME'' // '' In the meantime you may think again about the'',
C    2 '' advisability''/ '' of correcting the observed line positions''
C    3 / )' )
C     WRITE(NCRT,'(/
C    2 '' The calculated twothetas present the ideal pattern,'',
C    3 '' without'' / '' any systematic or random errors, whereas the'',
C    4 '' observed''/'' values are due to have  small or large '',
C    5 '' errors.'' )' )
C     WRITE(NCRT,'(
C    1 '' Therefore it seems logical to *correct* the observed values''
C    2 / '' in order to get the best agreement with the calculated'',
C    3 ''  pattern.'' )' )
      CALL THREED
C  ---------------------------------------------------------------------
C  THE PROCEDURE THREED TRIES TO FIND THE ANGLE BETWEEN TWO
C  INTERSECTING ZONES, DETERMINED BY THE LAST SECTION.(REAR),
C  THE POSSIBLE  LATTICES WERE ON  EVERY FOURTH POSITION IN ROSTER.
C  IF MORE THAN ONE VALUE OF D IS FOUND, THE ADDITIONAL POSSIBLE
C  LATTICES ARE STORED AFTER THE FIRST. A MAXIMUM OF FOUR DIFFERENT
C  VALUES OF D CAN THUS BE ACCOMODATED.  EMPTY POSITIONS ARE MARKED BY
C  A ZERO IN POSITION 7.
C-----------------------------------------------------------------------
      WRITE(IOUT ,9960) NAME
C     WRITE(NCRT ,9961) SNAME
      N4=LINCO+4
      N=0
      DO 1910 I=1,N4
      IF (ROSTER(I,7).LT.1.)GO TO  1910
      N=N+1
      DO 1905 J=1,8
 1905 ROSTER(N,J)=ROSTER(I,J)
      WRITE(IOUT ,9937)  N,(ROSTER(N,J),J=1,8)
C     WRITE(NCRT ,9937)  N,(ROSTER(N,J),J=1,8)
 1910 CONTINUE
      CALL TIMER(5)
      N4=N
C  ---------------------------------------------------------------------
C--THE LATTICES FOUND WILL BE PUT INTO A STANDARD SHAPE.(NORMALISED)
C  ---------------------------------------------------------------------
      CALL NTEST(NTST,6)
      IF (N4 .EQ. 0 ) THEN
         WRITE(NSUMM,9924)
C        WRITE(NCRT ,9924)
         WRITE(IOUT ,9925)
         RETURN
      END IF
C
C  ROSTER(N,1..6) CONTAIN THE LATTICE CONSTANTS, 7 GIVES THE NUMBER
C  OF HITS AND 8 CONTAINS THE PEDIGREE.
C
      write(ncrt, '(// ''*****************************************'',
     * / '' THE LATTICES WILL NOW BE NORMALIZED  '',/
     * '' ***************************************'')')
      DO 1990 J=1,N4
      DO 1930 I=1,8
 1930 CEL(I)=ROSTER(J,I)
      CALL NORM3
      DO 1940 I=1,8
 1940 ROSTER(J,I)=CEL(I)
      IF (J .EQ. 1) GO TO 1990
      MJ=J-1
C  ---------------------------------------------------------------------
C  FIRST WE MARK 'EQUAL' LATTICES .
C  ---------------------------------------------------------------------
      DO 1980 K=1,MJ
      U=0.0
      DO 1950 I=1,6
 1950 U=U+ABS(ROSTER(K,I)-ROSTER(J,I))
      IF (U .GT. FMINEQ) GO TO 1990
C  ---------------------------------------------------------------------
C  IF TWO LATTICES ARE EQUAL,WE SET ROSTER(N,7)=0 AND GIVE THE
C  PEDIGREE OF THE OTHER IN ROSTER(N,9)
C  ---------------------------------------------------------------------
      IF (ROSTER(K,7) .LT. ROSTER(J,7) ) THEN
         ROSTER(K,7)=0.
         ROSTER(K,9)=ROSTER(J,8)
      ELSE
         ROSTER(J,7)=0.
         ROSTER(J,9)=ROSTER(K,8)
      END IF
 1980 CONTINUE
 1990 CONTINUE
 2000 CALL TIMER(6)
C-----------------------------------------------------------------------
C  THE LATTICES ARE NOW NORMALIZED,AND THE PATHOLOGICAL CASES HAVE
C  BEEN MARKED. THE NEXT STEP IS TO TRY AND REFINE THE LATTICES THAT
C  ARE LEFT.
C  ---------------------------------------------------------------------
      ALL=.FALSE.
      CALL NTEST(NTST,7)
      write(ncrt, '(// ''*****************************************'',
     * / ''   THE LATTICES WILL NOW BE REFINED  '',/
     * '' ***************************************'')')
      DO 2100 J=1,N4
      IF (ROSTER(J,1) .LT. FMINEQ) GO TO 2100
      IF (ROSTER(J,7) .LT. FMINEQ) GO TO 2100
      IF (TEST) WRITE(IOUT ,9909) J
C  COUNT THE NUMBER OF TIMES THAT THIS LATTICE GOES THROUGH REFPAR AND
C  NORM3 (CHANGE 150986)
      NRNORM=0
      DO 2030 I=1,10
 2030 CEL(I)=ROSTER(J,I)
      CEL(10)=CEL(8)
 2040 CEL(7)=0.
      ZERTOT=0.
C     write(ncrt,'('' Input '',i3, 6F8.1 )') j, (cel(i),i=1,6)
C-----------------------------------------------------------------------
C  A FIRST ROUND OF LEAST SQUARES (IN REFPAR) WILL NOW BE RUN.
C-----------------------------------------------------------------------
      CALL REFPAR(NSOL,ALL)
C     WRITE(NCRT,'('' Output'',I3,6F8.1,4F5.0)') J,CEL
      IF (CEL(7) .LT. PRNTLN) GO TO 2080
      IF (CEL(8) .LT. PRNTMR) GO TO 2080
      DO 2060 I=1,6
 2060 OLD(I)=CEL(I)
      CALL NORM3
      NRNORM=NRNORM+1
      IF (CEL(1) .LT. FMINIM) GO TO 2080
      U=0.
      DO 2070 I=1,6
 2070 U=U+ABS(CEL(I)-OLD(I))
      IF (NRNORM .GT. 3) THEN
         WRITE(IOUT ,9905) J, (CEL(I),I=1,10)
         WRITE(NSUMM,9905) J, (CEL(I),I=1,10)
         GO TO 2080
      END IF
      IF (U .GT. 0.1) GO TO 2040
C  IF NORM3 CHANGES THE RECIPROCAL CELL, WE HAVE TO DETERMINE
C  THE BRAVAIS TYPE AGAIN. (AND REFINE THE NEW PARAMETERS)
C
 2080 DO 2090 K=1,10
 2090 ROSTER(J,K)=CEL(K)
      ROSTER(J,11)=ZERTOT
C     write(ncrt,'('' NORMout'',i2, 6F8.1 // )') j, (cel(i),i=1,6)
 2100 CONTINUE
C-----------------------------------------------------------------------
C  PRINT THE FATE OF THE DISCARDED LATTICES AND
C  COLLECT THE GOOD ONES.
C-----------------------------------------------------------------------
      NR=0
      IF (ENL) WRITE(IOUT ,9936) NAME
      DO 2200 J=1,N4
      IF (ROSTER(J,1) .GT. FMINEQ) GO TO 2110
      IF (ENL) WRITE(IOUT ,9910) J,(ROSTER(J,I),I=1,6),ROSTER(J,8)
      GO TO 2200
 2110 IF (ROSTER(J,7) .GT. FMINEQ) GO TO 2120
      IF (ENL) WRITE(IOUT ,9911) J,(ROSTER(J,I),I=1,9)
      GO TO 2200
 2120 IF (ROSTER(J,7) .GT. PRNTLN) GO TO 2150
      IF (ENL) WRITE(IOUT ,9912) J,(ROSTER(J,I),I=1,10)
      GO TO 2200
 2150 IF (ROSTER(J,8) .GT. PRNTMR) GO TO 2160
      IF (ENL) WRITE(IOUT ,9913) J,(ROSTER(J,I),I=1,10)
      GO TO 2200
C  FINALLY,THE LATTICE IS ACCEPTED
 2160 NR=NR+1
      DO 2180 K=1,12
 2180 ROSTER(NR,K)=ROSTER(J,K)
      IF (ENL) WRITE(IOUT ,9914) J,(ROSTER(NR,I),I=1,10)
C     WRITE(NCRT ,9914) J,(ROSTER(NR,I),I=1,6),ROSTER(NR,8)
 2200 CONTINUE
      IF (ENL) THEN
         WRITE(IOUT ,9915)
         WRITE(IOUT ,9916)
      END IF
      CALL TIMER(7)
C-----------------------------------------------------------------------
C  A DOUBLE SORT WILL NOW BE CARRIED OUT, FIRST ON THE NUMBER OF
C  LINES INDEXED(POS. 7)   AND SECONDLY ON THE FIGURE OF MERIT (POS. 8)
C  OF THE LATTICES.
C-----------------------------------------------------------------------
      IF (NR .EQ. 0) THEN
         WRITE(NSUMM,9924)
         WRITE(IOUT ,9990)
C        WRITE(NCRT ,9924)
         RETURN
      END IF
      WRITE(IOUT ,9950) NAME
      WRITE(IOUT ,9951)
      WRITE(NSUMM,9980) SNAME
C     WRITE(NCRT ,9980) SNAME
      JJ=100
      DO 3050 L=1,NR
      K=0
      AA=0.
      DO 3030 H=L,NR
      M= ROSTER(H,7)+0.5
      B= ROSTER(H,8)
      IF (M-K) 3030,3020,3010
 3010 K=M
      I=H
      AA=B
      GO TO 3030
 3020 IF(B.LE.AA) GO TO 3030
      AA=B
      I=H
 3030 CONTINUE
      IF (K.GE.JJ) GO TO 3040
      WRITE(IOUT ,9952)
      WRITE(NSUMM,9952)
      JJ=K
 3040 DO 3045 N=1,12
      A= ROSTER(I,N)
      ROSTER(I,N)= ROSTER(L,N)
      ROSTER(L,N)=A
      IF (N .LE. 10) CEL(N)=A
 3045 CONTINUE
C  CALCULATE VOLUME OF UNIT CEL AND PRINT
      CALL UNTCEL(WMOL,DOBS,VOL,0)
      KKK=NINT(ROSTER(L,9))
      TET=TWORAD*ROSTER(L,11)
      WRITE(IOUT ,9953) (ROSTER(L,N),N=1,8),BRAVTP(KKK),
     * ROSTER(L,10), VOL,TET
      WRITE(NSUMM,9983) (ROSTER(L,N),N=1,8),BRAVTP(KKK)
C     WRITE(NCRT ,9983) (ROSTER(L,N),N=1,8),BRAVTP(KKK)
 3050 CONTINUE
C-----------------------------------------------------------------------
C--END OF SORT AND PRINT.
C-----------------------------------------------------------------------
      WRITE(IOUT  ,9963)
      WRITE(NSUMM ,9973)
      IF (ZERREF) THEN
         WRITE(IOUT  ,9962)
         WRITE(NSUMM ,9962)
C        WRITE(NCRT  ,9962)
      END IF
      CALL NTEST(NTST,8)
C-----------------------------------------------------------------------
C  WE NOW PRINT OUT THE BEST *NSOLMX* SOLUTIONS WITH AN INDEXED LIST
C  OF THE FIRST TWENTY LINES.  IF YOU HAVE SET  'TEST' THEN YOU ALSO
C  GET  THE Q-VALUES PRINTED OUT AS A  LATTICE.
C-----------------------------------------------------------------------
      IF (NR .LT. NSOLMX) NSOLMX=NR
      WRITE(IOUT ,9964) NSOLMX
C     WRITE(NCRT ,9964) NSOLMX
      N=0
      MIN=-1
      SELF=.TRUE.
      DO 3060 I=1,3
 3060 IF (NSYST(I) .NE.0) N=I
      IF (N .NE. 0) SELF=.FALSE.
      IF (SELF) GO TO 3090
C  SELF=.FALSE. IF WE WANT TO FORCE A CERTAIN CRYSTAL SYSTEM.
C     write(ncrt,'(/'' In the following, we try to force a certain'',
C    * '' crystal system''/)')
      N=0
      M=0
      DO 3070 K=1,3
      IF (NSYST(K) .EQ. 1) N=N+1
      IF (NSYST(K) .EQ.(-1) ) M=M+1
 3070 CONTINUE
      IF (N .GT. 0) WRITE(IOUT ,9965)
      IF (M .GT. 0) WRITE(IOUT ,9966)
      IF (N .GT. 0) MIN=1
      IF (M .GT. 0) MIN=0
      DO 3080 M=1,MAX
      DIF=OBS(M)-OBSMT(M)
      OBSMT(M)=OBSMT(M)-DIF
 3080 OBSPT(M)=OBSPT(M)+DIF
C  THE TOLERANCES HAVE BEEN DOUBLED WHEN YOU WANT TO  FORCE A CERTAIN
C  CRYSTAL SYSTEM.
      WRITE(IOUT ,9967)
 3090 NSOL=0
      DO 3200 I=1,NR
      IF (SELF) GO TO 3120
      NORDE=1
      DO 3110 J=4,6
 3110 IF (ABS(ROSTER(I,J)) .GT. FMINEQ) NORDE=NORDE+1
      IF (NORDE .EQ. 4) NORDE=3
      IF (NSYST(NORDE) .LT. MIN) GO TO 3200
 3120 NSOL=NSOL+1
C  FIND OUT WHETHER THERE ARE IDENTICAL SOLUTIONS AMONG THE BEST ONES,
C  SKIP REFINEMENT + PRINT OUT IF THERE ARE.
      IF (I .EQ. 1) GO TO 3140
      A=0.
      K=I-1
      DO 3130 J=1,6
 3130 A=A+ABS(ROSTER(K,J)-ROSTER(I,J))
      IF (A .GT. FMINEQ) GO TO 3140
C  THE LATTICE IS NEARLY THE SAME AS THE PRECEDING ONE
      WRITE(IOUT ,9949) I,K
C     WRITE(ncrt ,9949) I,K
      GO TO 3170
 3140 DO 3150 J=1,10
 3150 CEL(J)= ROSTER(I,J)
      IF (NSOL .EQ. 1) WRITE(NSUMM,9970) (CEL(K),K=1,8)
C     IF (NSOL .EQ. 1) WRITE(ncrt ,9970) (CEL(K),K=1,8)
      ZERTOT=ROSTER(I,11)
      CALL REFPAR(NSOL,ALL)
      IF (NSOL .EQ. 1) WRITE(NSUMM,9970) (CEL(K),K=1,8)
C     IF (NSOL .EQ. 1) WRITE(NCRT ,9970) (CEL(K),K=1,8)
      DO 3160 J=1,10
 3160 ROSTER(I,J)=CEL(J)
      ROSTER(I,11)=ZERTOT
 3170 IF (NSOL .EQ. NSOLMX) GO TO 3205
 3200 CONTINUE
C  AFTER THIS REFINEMENT CYCLE, A NEW SORT IS MADE.
C  THE NEW CRITERION IS: (FIGURE OF MERIT)/ (21-LINES INDEXED)
C  ROSTER:1-6 CELL CONST., 7=LINES INDEXED, 8=M20, 9-BRAVTYP,
C          10=PEDIGREE, 11=ZEROSHIFT,  12=RANKING.
 3205 NSOL=NSOLMX
      IF (NR .LT. NSOLMX) NSOL=NR
      DO 3210 I=1,NSOL
 3210 ROSTER(I,12)=ROSTER(I,8)/(21.0-ROSTER(I,7) )
      DO 3250 I=1,NSOL
      AA=0.
      DO 3230 J=I,NSOL
         IF (ROSTER(J,12) .GT. AA) THEN
            AA=ROSTER(J,12)
            L=J
         END IF
 3230 CONTINUE
      DO 3240 N=1,12
      A=ROSTER(I,N)
      ROSTER(I,N)=ROSTER(L,N)
      ROSTER(L,N)=A
 3240 CONTINUE
 3250 CONTINUE
      CALL TIMER(8)
C  PRINT FINAL TABLE OF LATTICES
      WRITE(IOUT ,9954)  NAME,NSOL
      WRITE(NSUMM,9984) SNAME,NSOL
C     WRITE(NCRT ,9984) SNAME,NSOL
      DO 3260 I=1,NSOL
      TET=TWORAD*ROSTER(I,11)
      KKK=NINT( ROSTER(I,9) )
      WRITE(IOUT ,9955) ( ROSTER(I,N),N=1,8),  ROSTER(I,10),
     1   BRAVTP(KKK),TET
      WRITE(NSUMM,9983) ( ROSTER(I,N),N=1,8), BRAVTP(KKK)
C     WRITE(NCRT ,9983) ( ROSTER(I,N),N=1,8), BRAVTP(KKK)
 3260 CONTINUE
C     IF (ZERREF) WRITE(NCRT,9962)
      CALL NTEST(NTST,9)
C-----------------------------------------------------------------------
C--PRINT THE VALUES OF THE PARAMETERS OF THE DIRECT LATTICE.
C-----------------------------------------------------------------------
      WRITE(IOUT ,9956)
      WRITE(NSUMM,9956)
C     WRITE(NCRT ,9956)
      DO 3280 I=1,NSOL
      DO 3270 J=1,10
 3270 CEL(J)= ROSTER(I,J)
      CALL UNTCEL(WMOL,DOBS,VOL,1)
      WRITE(NSUMM,9988) (CEL(J),J=1,7)
C     WRITE(NCRT ,9988) (CEL(J),J=1,7)
 3280 CONTINUE
      IF ( ZERREF ) THEN
         WRITE(NSUMM,9962)
C        WRITE(NCRT ,9962)
      END IF
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  THE BEST SOLUTIONS ARE TESTED ON HIGHER SYMMETRIES,THAT MAY BE
C  CONCEALED IN THE Q-VALUES.
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C     WRITE(NCRT, 9947)
      DO 3320  ISOL=1,NSOL
      DO 3310 J=1,10
 3310 CEL(J)=ROSTER(ISOL,J)
      CALL SYMTST
 3320 CONTINUE
      WRITE(IOUT ,9957)
      WRITE(IOUT ,9959)
      WRITE(NSUMM,9959)
C     WRITE(NCRT ,9959)
      WRITE(IOUT ,9958) NAME
      WRITE(NSUMM,'(/1X,A70)' ) SNAME
      WRITE(NCRT ,'(/1X,A70)' ) SNAME
      CALL TIMER(9)
C  ---------------------------------------------------------------------
C  THE BEST SOLUTION IS NOW USED TO TRY AND INDEX ALL LINES ENTERED.
C-----------------------------------------------------------------------
      IF((ROSTER(1,7) .LT. 17.9).OR.(ROSTER(1,8) .LT. 10.0)) THEN
         WRITE(NSUMM,9924)
         WRITE(NCRT ,9924)
         WRITE(NCRT ,9976)
         RETURN
      END IF
      CALL SRTSYM
      IF ((SYMCON(1,3).GT.0.1) .AND. (SYMCON(1,4) .GT. 0.9*MAX))  THEN
         CALL SYMPRT
      ELSE
         ALL=.TRUE.
         DO 3400 I=1,10
 3400    CEL(I)=ROSTER(1,I)
         ZERTOT=ROSTER(1,11)
         WRITE(NSUMM,9972)
C        WRITE(NCRT ,9972)
         WRITE(NSUMM,9970) (CEL(K),K=1,8)
C        WRITE(NCRT ,9970) (CEL(K),K=1,8)
         CALL REFPAR(1,ALL)
         WRITE(NCRT,'(/'' THE BEST RESULT IS:  '')')
         WRITE(NSUMM,9970) (CEL(K),K=1,8)
         WRITE(NCRT ,9970) (CEL(K),K=1,8)
         WRITE(NSUMM,9971) TWORAD*ZERTOT , 3*TWORAD*ZERTOT
         WRITE(NCRT ,9971) TWORAD*ZERTOT , 3*TWORAD*ZERTOT
         IF (ZERREF) THEN
            WRITE(NSUMM,9962)
C           WRITE(NCRT ,9962)
            WRITE(IOUT ,9962)
         END IF
         ROSTER(1,11)=ZERTOT
         WRITE(IOUT ,9956)
         WRITE(NSUMM,9956)
         WRITE(NCRT ,9956)
         CALL UNTCEL(WMOL,DOBS,VOL,1)
         WRITE(NSUMM,9988) (CEL(J),J=1,7)
         WRITE(NCRT ,9988) (CEL(J),J=1,7)
         WRITE(NSUMM,'(/,1X,A70)' ) SNAME
         WRITE(NCRT ,'(/,1X,A70)' ) SNAME
         WRITE(NCRT ,9974)
         WRITE(NCRT ,9959)
      END IF
      CALL TIMER(9)
      NRRUN=2
      RETURN
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
 9905 FORMAT(/' LATTICE',I3,' SWITCHES BACK AND FORTH BETWEEN NORM3 ',
     * 'AND REFINE.' / ' POSSIBLY REFINE CHANGES THE ORDER OF THE ',
     * 'CELL CONSTANTS AND NORM3'/ ' SWITCHES THEM BACK.   THE CELL ',
     * 'IS ACCEPTED AS:' / 6F10.2 / 4F8.0 )
 9909 FORMAT(//,' LATTICE NR.',I3,'  WILL NOW BE REFINED AND',
     * ' NORMALISED',10(2H==)  )
 9910 FORMAT(1H ,I5,6F8.1,24X,F8.0,20H DISCARDED BY NORM3  )
 9911 FORMAT(1H ,I5,6F8.1,F8.0,16X,F8.0,23H IS THE SAME AS LATTICE,
     *  F6.0)
 9912 FORMAT(1H ,I5,6F8.1,4F8.0,25H NOT ENOUGH LINES INDEXED  )
 9913 FORMAT(1H ,I5,6F8.1,4F8.0,28H FIGURE OF MERIT IS TOO LOW.  )
 9914 FORMAT(1H ,I5,6F8.1,4F8.0, 20H LATTICE ACCEPTED.   )
 9915 FORMAT(///47H ***  NOTES  ***    THE SUBROUTINE ** THREED **,
     1       50HCOLLECTS TOO MANY LATTICES (BETTER TOO MANY THAN T,
     2       12HOO LITTLE).    /
     3       50H SOME OF THESE MUST BE DISCARDED BECAUSE THE LATTI,
     4       50HCE IS IMPOSSIBLE (E.G.CONTAINS NEGATIVE Q-VALUES),/
     5       50H OTHERS MUST BE DISCARDED BECAUSE THE ALLEGED SYMM,
     6       50HETRY REDUCES THE RECIPROCAL CELL EDGES BELOW THE  /
     7       50H MINIMUM ALLOWED.                                 )
 9916 FORMAT(50H     AFTER NORMALISING, SOME LATTICES TURN OUT TO ,
     9       50HBE THE SAME. ONLY ONE OF THESE IS RETAINED. THESE /
     A       50H LATTICES ARE INDICATED.                          /
     B       50H     FINALLY, THE PROGRAM TRIES TO INDEX THE PATTE,
     C       52HRN WITH THESE LATTICES AND REFINES THEIR PARAMETERS./
     D       50H IF A LATTICE DOES NOT INDEX ENOUGH LINES OR IF IT,
     E       51HS FIGURE OF MERIT IS BELOW ALL HOPE FOR IMPROVEMENT/
     F       50H THAT LATTICE IS DROPPED TOO.                       )
 9924 FORMAT(/,' NOT ONE ACCEPTABLE LATTICE HAS BEEN FOUND. ' )
 9925 FORMAT(50H NO LATTICES HAVE BEEN FOUND. TRY AGAIN WITH E.G. ,
     1       50HLARGER TOL3 (COL. 16-20).  THIS PROBLEM IS SKIPPED)
 9936 FORMAT(1H ,20X,A80 / 40(3H---)/
     *60H               LATTICES REDUCED AND PUT INTO STANDARD FORM //
     *56X,24HLINES  FIGURE    BRAVAIS/
     *56H SERIAL   A       B       C        D       E       F     ,
     *34HINDXD  OF MERIT  LATTICE  PEDIGREE   )
 9937 FORMAT(1H ,I5,6F8.1, 2F8.0)
 9947 FORMAT(///40X,24H ****   ATTENTION   ****//
     160H 1. ANY *SOLUTION* WITH A FIGURE OF MERIT LESS THAN 4.0 IS  /
     260H     WORTHLESS AND SHOULD BE REJECTED RIGHT AWAY.           //
     360H 2. ANY *SOLUTION*THAT LEAVES MORE THAN TWO VERY WEAK LINES /
     460H    UNEXPLAINED  IS WORTHLESS.   HOWEVER, IF THE FIGURE OF  /
     560H    MERIT IS GREATER THAN 10.0 IT MIGHT BE WORTHWHILE TO    /
     660H    EXAMINE THE INPUT DATA  AND THE *SOLUTION* MORE CLOSELY./
     760H 3. EVEN *SOLUTIONS* THAT INDEX ALL LINES WITH A FIGURE OF  /
     860H    MERIT GREATER THAN 10.0 SHOULD NOT BE ACCEPTED          /
     950H    UNCRITICALLY WITHOUT FURTHER INVESTIGATION.           //)
 9949 FORMAT(9H SOLUTION,I3,35H IS NOT PRINTED, IT IS THE SAME AS ,
     2 9HSOLUTION ,I2)
 9950 FORMAT(///,20X,A80/ 40(3H---)  )
 9951 FORMAT(// ,14X,47HTRIAL LATTICES AFTER INDEXING AND LS REFINEMENT
     *//14X,52HONLY THE FIRST 20 LINES ARE CONSIDERED FOR INDEXING  //
     *59X,24HLINES  FIGURE    BRAVAIS/
     *95H      A        B        C        D         E        F    INDEXE
     *D  OF MERIT  LATTICE  PEDIGREE   ,18HVOLUME  ZEROSHIFT  )
 9952 FORMAT(1H )
 9953 FORMAT(1H ,6F9.1,F9.0,F9.1,8X,A1,F9.0,F8.1,F10.4 )
 9954 FORMAT(///,20X,A80/ 40(3H---) // 30X, 4HTHE ,I2,
     1        25H MOST PROBABLE SOLUTIONS //// 58X,
     2 34HLINES  FIGURE OF           BRAVAIS/
     3 60H    Q(A)     Q(B)     Q(C)      Q(D)     Q(E)     Q(F)   IND,
     4 44HEXED   MERIT   PEDIGREE  LATTICE  ZEROSHIFT  )
 9955 FORMAT(1H ,6F9.2,F9.0,F9.1,F9.0,8X,A1,F10.4)
 9956 FORMAT(//1H ,20X,38HTHE DIRECT CONSTANTS OF THESE LATTICES//
     * 60H     A        B        C       ALFA     BETA     GAMMA      ,
     * 6HVOLUME)
 9957 FORMAT(1H ///40X,24H ****   ATTENTION   ****//
     160H 1. ANY *SOLUTION* WITH A FIGURE OF MERIT LESS THAN 4.0 IS W,
     260HORTHLESS AND SHOULD BE REJECTED RIGHT AWAY.                 //
     360H 2. ANY *SOLUTION*THAT LEAVES MORE THAN TWO VERY WEAK LINES ,
     460HUNEXPLAINED  IS WORTHLESS.   HOWEVER, IF THE FIGURE OF MERIT/
     560H    IS GREATER THAN 10.0 IT MIGHT BE WORTHWHILE TO EXAMINE  ,
     660HTHE INPUT DATA  AND THE *SOLUTION* MORE CLOSELY.            //
     760H 3. EVEN *SOLUTIONS* THAT INDEX ALL LINES WITH A FIGURE OF M,
     860HERIT GREATER THAN 10.0 SHOULD NOT BE ACCEPTED UNCRITICALLY  /
     933H    WITHOUT FURTHER INVESTIGATION//)
 9958 FORMAT(1H ,A80)
 9959 FORMAT(// 1X,23(3H***) / 2H *,67X,1H* /,
     1 ' * THIS PROGRAM GIVES A NUMBER OF SUGGESTIONS THAT MAY HELP',
     2 ' YOU TO   *' /' * FIND THE UNIT CELL THAT EXPLAINS YOUR',
     3 ' EXPERIMENTAL DATA. HOWEVER  *'/2H *,67X,'*'/
     4  2H *,5X,19(3HWWW),6H     * /
     4  ,8H *     W,55X,7HW     */ 8H *     W,
     5  '  IT IS ENTIRELY THE USERS RESPONSIBILITY TO DECIDE    W     *'
     6 ,/ 8H *     W,'  WHETHER ANY OF THE SUGGESTED UNIT CELLS IS THE',
     7  7X,'W     *' / ' *     W   CORRECT CELL. ',38X,'W     *' /
     8  8H *     W, 55X, 7HW     * / 7H *      ,
     9 19(3HWWW), 6H     * / 2H *,67X,1H*/1H ,23(3H***) )
 9960 FORMAT(1H ,20X,A80 / 40(3H---)  //
     160H POSSIBLE LATTICES BASED ON THE ABOVE COMBINATION OF ZONES  //
     258H SERIAL    A       B       C        D       E       F       ,
     315HHITS  PEDIGREE   )
 9961 FORMAT(////1H ,A70 / 35(2H--)  // 10X,
     160H POSSIBLE LATTICES BASED ON THE ABOVE COMBINATION OF ZONES  //
     258H SERIAL    A       B       C        D       E       F       ,
     315HHITS  PEDIGREE   )
 9962 FORMAT(/// 38(2H**)/'* THE OBSERVED POSITIONS OF THE ',
     2 'DIFFRACTION LINES ARE CORRECTED HERE       *' /
     3 '* WITH A  *ZERO-CORRECTION*, WHICH STANDS FOR THE SUM OF',
     4 ' A REAL            *'/'* ZEROPOINT ERROR PLUS A SPECIMEN ',
     5 ' DISPLACEMENT ERROR PLUS A TRANSPARENCY  *', /
     6 '* ERROR. THE CORRECTION IS A CONSTANT OVER THE 2THETA ',
     7 'RANGE.               *'/38(2H**) )
 9963 FORMAT(//7H NOTES //
     160H  1. *LINES INDEXED* REFERS TO THE NUMBER OF LINES FROM THE ,
     260HFIRST 20 OBSERVED LINES THAT HAVE BEEN ACCEPTED AS INDEXED  /
     360H     BY THIS LATTICE, UP TO A MAXIMUM OF 20, WHICH WOULD REP,
     460HRESENT COMPLETE SUCCESS.                                    //
     560H  2. *FIGURE OF MERIT* IS DEFINED AS QOBS(20)/(2*MEANDIFF*NC,
     660HALC) WHERE DIFFERENCES ARE TAKEN FOR INDEXED LINES ONLY     /
     760H     AND *NCALC* IS THE NUMBER OF LINES GENERATED UP TO Q=1.,
     860H003*Q(20),REGARDLESS OF WHETHER OR NOT THEY CONTRIBUTE TO   /
     960H     THE INDEXINGS, BUT EXCLUDING SYSTEMATIC ABSENCES DUE TO,
     *27H THE BRAVAIS LATTICE TYPE. /
     A60H     IT IS CLOSELY RELATED TO  M20 ,DE WOLFF(J.APPL.CRYST.19,
     B60H68,1972), ALLOWING FOR LESS THAN 20 SUCCESSFUL INDEXINGS.   )
 9964 FORMAT(4H THE, I3,
     *       50H BEST SOLUTIONS ARE NOW PRINTED MORE EXTENSIVELY.   )
 9965 FORMAT(50H THE CHANCES FOR SOME LATTICES ARE ENHANCED. ONLY ,
     *       50HTHOSE ARE PRINTED OUT.                            )
 9966 FORMAT(50H  THE PRINTING OF SOME  LATTICES IS SUPPRESSED    )
 9967 FORMAT(50H FOR THE LATTICES IN THE CRYSTAL SYSTEMS THAT ARE ,
     *       50HTREATED PREFERENTIALLY, THE TOLERANCE HAS BEEN    /
     2       54H DOUBLED AND TWO ROUNDS OF LEAST SQUARES ARE EXECUTED.,
     3       50H AFTERWARDS, THESE SOLUTIONS ARE SORTED WITH      /
     4       50H THE OTHER SOLUTIONS ON LINES INDEXED AND FIGURE  ,
     5       50HOF MERIT.                                         /
     6       50H IF YOUR PREFERRED SYSTEM DOES NOT COME OUT ON TOP,
     7       54H THERE MIGHT BE SOMETHING AMISS WITH YOUR ASSUMPTIONS.)
 9970 FORMAT(//'    SOLUTION NR. 1  '/ 1X,6F9.2,F6.0,F6.1  )
 9971 FORMAT(' ZEROSHIFT=',F9.4,' DEGREES TWOTHETA'/17(4H****) /
     2 ' *  THIS ZEROSHIFT COULD CORRESPOND TO A SPECIMEN',
     3 ' DISPLACEMENT OF', 2(1H ),1H*/ 2H *,F7.2, '  MILLIMETER',
     4 ' IN A "STANDARD" DIFFRACTOMETER.',14(1H ),1H* /' *  ONLY',
     5 ' THE "OWNER" OF THE DATA CAN JUDGE ITS PROBABILITY.',
     6  8(1H ),1H*  / 17(4H****) / )
 9972 FORMAT(//'  THE BEST SOLUTION IS NOW USED TO TRY AND INDEX ',
     2 'ALL GIVEN LINES' //)
 9973 FORMAT(//7H NOTES //
     160H  1. *LINES INDEXED* REFERS TO THE NUMBER OF LINES FROM THE /
     260H     FIRST 20 OBSERVED LINES THAT HAVE BEEN ACCEPTED AS     /
     360H     INDEXED BY THIS LATTICE, UP TO A MAXIMUM OF 20, WHICH  /
     460H     WOULD REPRESENT COMPLETE SUCCESS.                      //
     560H  2. *FIGURE OF MERIT* IS DEFINED AS QOBS(20)/(2*MEANDIFF*  /
     660H     NCALC) WHERE DIFFERENCES ARE TAKEN FOR INDEXED LINES   /
     760H     ONLY AND *NCALC* IS THE NUMBER OF LINES GENERATED UP TO/
     860H     Q=1.003*Q(20), REGARDLESS OF WHETHER OR NOT THEY       /
     960H     CONTRIBUTE TO  THE INDEXINGS, BUT EXCLUDING SYSTEMATIC /
     *60H     ABSENCES DUE TO THE BRAVAIS LATTICE TYPE.              /
     A60H     IT IS CLOSELY RELATED TO  M20 (READ: DE WOLFF, J.APPL. /
     B60H     CRYST. 1968, 1972)  ALLOWING FOR LESS THAN 20          /
     C50H     SUCCESSFUL INDEXINGS.                               // )
 9974 FORMAT(// ' STUDY ALSO THE RESULTS IN THE OTHER OUTPUT FILES!!')
 9976 FORMAT(// ' ********  END OF PROGRAM  ********' )
 9980 FORMAT(////1H ,A70/ 35(2H--)  //
     1       1H ,14X,47HTRIAL LATTICES AFTER INDEXING AND LS REFINEMENT
     2//14X,52HONLY THE FIRST 20 LINES ARE CONSIDERED FOR INDEXING  //
     3 55X,'LINES FIGUR LAT' /
     4 '      A        B        C        D         E        F  INDXD',
     5 ' MERIT TYP'  )
 9983 FORMAT(1H ,6F9.1,F6.0,F6.1,2X,A1)
 9984 FORMAT(///1H ,A70/ 35(2H--) //
     1 20X,'THE ',I2, 25H MOST PROBABLE SOLUTIONS ////
     2 55X,'LINES FIGUR LAT' /
     3 '    Q(A)     Q(B)     Q(C)     Q(D)      Q(E)     Q(F) INDXD',
     4 ' MERIT TYP'  )
 9988 FORMAT(1H ,6F9.4,F12.2)
 9990 FORMAT(/52H NOT ONE ACCEPTABLE LATTICE HAS BEEN FOUND FOR THIS
     2     , 52H PROBLEM. USUALLY THIS MEANS THAT YOUR DATA ARE NOT
     3     / 50H GOOD ENOUGH. YOU MIGHT ALSO TRY OTHER PARAMETERS.  /
     4     / 50H THIS PROBLEM IS SKIPPED.                           )
      END
